#include <stdio.h>
#include <stdbool.h>
#include <stdlib.h>

#define INF 101

void _findcommon(int a[], int b[], int _common[], int *size, int max) {
    *size = 0;
    for (int i = 0; i <= max; i++) {
        //　共通部分集合を作る
        if (a[i] && b[i]) {
            _common[*size] = i;
            (*size)++;
        }
    }
}

void _findunion(int a[], int b[], int _union[], int *size, int max) {
    *size = 0;
    for (int i = 0; i <= max; i++) {
        //　和集合を作る
        if (a[i] || b[i]) {
            _union[*size] = i;
            (*size)++;
        }
    }
}

int main() {
    int a[INF] = {0}, b[INF] = {0}, _common[114514], _union[114514];
    int sizeCommon, sizeUnion, max = 0;

    // 入力
    printf("set A: ");
    int val;
    do {
        scanf("%d", &val);
        if (val != -1) {
            a[val] = 1;
            if (val > max) max = val;
        }
    } while (val != -1);

    printf("set B: ");
    do {
        scanf("%d", &val);
        if (val != -1) {
            b[val] = 1;
            if (val > max) max = val;
        }
    } while (val != -1);

    _findcommon(a, b, _common, &sizeCommon, max);
    _findunion(a, b, _union, &sizeUnion, max);
    
    // 出力
    printf("\nCommon subset: {");
    for (int i = 0; i < sizeCommon; i++) {
        printf("%d", _common[i]);
        if (i < sizeCommon - 1) printf(",");
    }
    printf("}\n");

    printf("Union set: {");
    for (int i = 0; i < sizeUnion; i++) {
        printf("%d", _union[i]);
        if (i < sizeUnion - 1) printf(",");
    }
    printf("}\n");

    return 0;
}
